## linphone-desktop 4.2.4

=== debian/changelog ===
linphone-desktop (4.2.4-3) unstable; urgency=medium

  * Release to unstable (Closes: #892325)

 -- Bernhard Schmidt <berni@debian.org>  Fri, 25 Dec 2020 21:57:09 +0100

linphone-desktop (4.2.4-2) experimental; urgency=medium

  * d/copyright: Include additional licenses with feedback from ftpmasters

 -- Bernhard Schmidt <berni@debian.org>  Sun, 13 Dec 2020 23:15:45 +0100

linphone-desktop (4.2.4-1) experimental; urgency=medium

  * Initial release (Closes: #892354)
    The build system behaves very cumbersome when building for a
    distribution, including attempting to build all libraries in-tree
    and fetching them using git at build-time. There is also some
    weirdness around installation paths. Fixes for both issues have
    been shamelessly borrowed from the ArchLinux and OpenSuSE repositories.

 -- Bernhard Schmidt <berni@debian.org>  Tue, 08 Dec 2020 22:42:08 +0100
