## linphone-desktop 4.2.5

=== debian/changelog ===
linphone-desktop (4.2.5-3) unstable; urgency=medium

  * Add qml-module-qtquick-controls to Depends (Closes: #978489)

 -- Bernhard Schmidt <berni@debian.org>  Sat, 02 Jan 2021 11:01:50 +0100

linphone-desktop (4.2.5-2) unstable; urgency=medium

  * Fix wrong version in Breaks/Replaces

 -- Bernhard Schmidt <berni@debian.org>  Sat, 26 Dec 2020 22:02:22 +0100

linphone-desktop (4.2.5-1) unstable; urgency=medium

  * New upstream version 4.2.5
  * Drop cmake version constraint, satisfied in oldstable
  * Add depends to linphone-common and various qml-module-qtquick-*
    (Closes: #978108, #978111)

 -- Bernhard Schmidt <berni@debian.org>  Sat, 26 Dec 2020 10:54:41 +0100
