=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
 Uploaders: Bernhard Schmidt <berni@debian.org>
-Build-Depends: cmake (>= 3.0),
+Build-Depends: cmake,
                debhelper-compat (= 12),
                liblinphone-dev (>= 4.4.15~),
                libqt5svg5-dev,
@@ -13,7 +13,7 @@
                qtdeclarative5-dev,
                qtquickcontrols2-5-dev,
                qttools5-dev,
-               qttools5-dev-tools,
+               qttools5-dev-tools
 Standards-Version: 4.5.0
 Homepage: http://www.linphone.org/
 Vcs-Browser: https://salsa.debian.org/pkg-voip-team/linphone-stack/linphone-desktop
@@ -21,9 +21,19 @@
 
 Package: linphone-desktop
 Architecture: any
-Depends: qml-module-qt-labs-platform, ${misc:Depends}, ${shlibs:Depends}
-Replaces: linphone (<< 4.4.0~)
-Breaks: linphone (<< 4.4.0~)
+Depends: linphone-common (>= 4.4.0~),
+         qml-module-qt-labs-platform,
+         qml-module-qtgraphicaleffects,
+         qml-module-qtquick-controls,
+         qml-module-qtquick-controls2,
+         qml-module-qtquick-dialogs,
+         qml-module-qtquick-layouts,
+         qml-module-qtquick-window2,
+         qml-module-qtquick2,
+         ${misc:Depends},
+         ${shlibs:Depends}
+Replaces: linphone (<< 4.0.0~)
+Breaks: linphone (<< 4.0.0~)
 Description: SIP softphone - graphical client
  Linphone is an audio and video internet phone using the SIP protocol.
  .
@@ -36,7 +46,8 @@
 
 Package: linphone
 Architecture: all
-Depends: linphone-desktop, ${misc:Depends}
+Depends: linphone-desktop,
+         ${misc:Depends}
 Section: oldlibs
 Description: SIP softphone - graphical client (transitional package)
  Linphone is an audio and video internet phone using the SIP protocol.
